package sk.blade.globalvibratetoggle;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.util.Log;

public class BootCompletedReceiver extends BroadcastReceiver {
    public BootCompletedReceiver() {
    }

    @Override
    public void onReceive(Context context, Intent intent) {
        if (DemoTools.isDemo()) DemoTools.scheduleNotification(context);

        if (DemoTools.isDemoExpired(context)) return;

        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(context.getApplicationContext());

        if (prefs.getBoolean("auto_wifi_enabled", false)) {
            Log.i("boot", "(state was/will be set by WiFiStatusListener");
            return;
        }

        boolean lastState = prefs.getBoolean("lastState", true);
        VibeManager.setEnabled(lastState);

        Intent updateIntent = new Intent(context.getApplicationContext(), VibeToggleWidget.class);
        updateIntent.setAction(VibeToggleWidget.ACTION_UPDATE);
        context.getApplicationContext().sendBroadcast(updateIntent);

        Log.i("boot", "Restored last state: "+(lastState ? "vibes enabled" : "vibes disabled"));
    }
}
