package sk.blade.globalvibratetoggle;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Build;
import android.preference.PreferenceManager;
import android.util.Log;

import java.util.Date;

/**
 * Created by 81403 on 11.9.2015.
 */
public class DemoTools {
    static long trialTimestamp = -1;

    public static boolean isDemo() {
        return false;
    }

    public static long getTimeLeft(Context context) {
        long now = new Date().getTime();

        if (now - getTrialTimestamp(context) < 0) {
            return 0;
        }

        return Math.max(0, 24 * 3600 * 1000 - (now - getTrialTimestamp(context)));
    }

    public static long getTrialTimestamp(Context context) {
        if (trialTimestamp == -1) {
            SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(context.getApplicationContext());
            trialTimestamp = prefs.getLong("trialTimestamp", -1);

            if (trialTimestamp == -1) {
                renewTimestamp(context);
            }
        }

        return trialTimestamp;
    }

    public static boolean isDemoExpired(Context context) {
        return isDemo() && getTimeLeft(context) == 0;
    }

    public static void renewTimestamp(Context context) {
        long nowTimestamp = new Date().getTime();

        trialTimestamp = nowTimestamp;

        SharedPreferences.Editor prefsEditor = PreferenceManager.getDefaultSharedPreferences(context.getApplicationContext()).edit();
        prefsEditor.putLong("trialTimestamp", nowTimestamp);
        prefsEditor.commit();
    }

    static void scheduleNotification(Context context) {
        long timeLeft = getTimeLeft(context);

        Log.i("DEMOTOOLS", "Scheduling expiry notification, time left: " + timeLeft);

        PendingIntent onExpiredIntent = PendingIntent.getBroadcast(context, 0, new Intent("sk.blade.globalvibratetoggle.NOTIFY_EXPIRED"), 0);

        AlarmManager alarmManager = (AlarmManager) context.getSystemService(Context.ALARM_SERVICE);
        if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
            alarmManager.setExact(AlarmManager.RTC_WAKEUP, System.currentTimeMillis() + timeLeft, onExpiredIntent);
        } else {
            alarmManager.set(AlarmManager.RTC_WAKEUP, System.currentTimeMillis() + timeLeft, onExpiredIntent);
        }
    }
}
