package sk.blade.globalvibratetoggle;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * Created by 81403 on 23.6.2015.
 */
public class VibeManager {

    private final static String devicePath = "/sys/devices/virtual/timed_output/vibrator/enable";

    public static boolean setEnabled(boolean enable) {
        try {
            Process shell = Runtime.getRuntime().exec("su");
            DataOutputStream outputStream = new DataOutputStream(shell.getOutputStream());
            if (enable) {
                outputStream.writeBytes("chmod 777 " + devicePath + "\n");
            } else {
                outputStream.writeBytes("chmod 444 " + devicePath + "\n");
            }

            outputStream.flush();
            outputStream.writeBytes("exit\n");
            outputStream.flush();
            outputStream.close();
            shell.waitFor();

            int exitValue = shell.exitValue();

            if (exitValue == 0) {
                return true;
            }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        return false;
    }

    public static boolean vibrationsEnabled() {
        try {
            Process shell = Runtime.getRuntime().exec("su");
            DataOutputStream outputStream = new DataOutputStream(shell.getOutputStream());
            outputStream.writeBytes("ls -l " + devicePath + "\n");
            outputStream.flush();
            outputStream.writeBytes("exit\n");
            outputStream.flush();
            outputStream.close();

            BufferedReader reader = new BufferedReader(new InputStreamReader(shell.getInputStream()));
            char[] buffer = new char[16];
            int read;
            StringBuffer shellOutput = new StringBuffer();
            read = reader.read(buffer, 0, 10);
            reader.close();

            if (read == -1) { // can't access the device path
                return true;
            }
            shellOutput.append(buffer, 0, read);

            shell.waitFor();
            //Log.i("xx", shellOutput.toString());

            if ("-r--r--r--".equals(shellOutput.toString())) {
                return false;
            } else {
                return true;
            }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        return true;
    }

    public static boolean toggleVibrations() throws Exception {
        boolean vibesOn;

        Process shell = Runtime.getRuntime().exec("su");
        DataOutputStream outputStream = new DataOutputStream(shell.getOutputStream());
        outputStream.writeBytes("ls -l " + devicePath + "\n");
        outputStream.flush();

        BufferedReader reader = new BufferedReader(new InputStreamReader(shell.getInputStream()));
        char[] buffer = new char[16];
        int read;
        StringBuffer shellOutput = new StringBuffer();
        read = reader.read(buffer, 0, 10);
        reader.close();

        if (read == -1) {
            return true;
        }

        shellOutput.append(buffer, 0, read);

        if ("-r--r--r--".equals(shellOutput.toString())) {
            outputStream.writeBytes("chmod 777 " + devicePath + "\n");
            vibesOn = true;
        } else {
            outputStream.writeBytes("chmod 444 " + devicePath + "\n");
            vibesOn = false;
        }

        outputStream.flush();
        outputStream.writeBytes("exit\n");
        outputStream.flush();
        outputStream.close();

        shell.waitFor();

        return vibesOn;
    }

    public static boolean isRooted() {
        String[] paths = { "/system/app/Superuser.apk", "/sbin/su", "/system/bin/su", "/system/xbin/su", "/data/local/xbin/su",
                           "/data/local/bin/su", "/system/sd/xbin/su", "/system/bin/failsafe/su", "/data/local/su", "/su/bin/su" };
        for (String path : paths) {
            if (new File(path).exists()) return true;
        }
        return false;
    }
}
